; *********************************************************************
; **************		DCF clock		***************
; *********************************************************************
;
list		p=16C84
; *************************
; *** Adresy a promenne ***
; *************************
indf		equ	$0
tmr0		equ	$1
status		equ	$3
c		equ	0
z		equ	2
rp0		equ	5
fsr		equ	$4
porta		equ	$5
dcf_in		equ	4
portb		equ	$6
dcf_ok		equ	7
intcon		equ	$B
toif		equ	2
toie		equ	5
gie		equ	7
option		equ	$1
trisa		equ	$5
trisb		equ	$6
state		equ	$C
dcf_bit		equ	0
dcf_last	equ	1
control_ok	equ	2
signal_error	equ	3
parity_min	equ	4
parity_hour	equ	5
dcf_time_lo	equ	$D
dcf_time_low	equ	$E
over		equ	3
dcf_time_hi	equ	$F
time_prescal	equ	$10
time_prescaler	equ	$11
sec_lo		equ	$12
sec_hi		equ	$13
min_lo		equ	$14
min_hi		equ	$15
hour_lo		equ	$16
hour_hi		equ	$17
two		equ	1
min_dcf_lo	equ	$18
min_dcf_hi	equ	$19
hour_dcf_lo	equ	$1A
hour_dcf_hi	equ	$1B
bit0		equ	0
bit1		equ	1
bit2		equ	2
bit3		equ	3
min_last_lo	equ	$1C
min_last_hi	equ	$1D
hour_last_lo	equ	$1E
hour_last_hi	equ	$1F
counter		equ	$20
pointer		equ	$21
parity_count	equ	$22
; *****************
; *** Konstanty ***
; *****************
dcf_100ms_min	equ	$2C
dcf_100ms_max	equ	$83
dcf_200ms_max	equ	$DA
; ****************
; *** Adresa 0 ***
; ****************
reset		bcf	status,rp0
		bcf	intcon,gie
		clrf	portb
		goto	start
; ************************************
; *** Adresa 4 - preruseni od tmr0 ***
; ************************************
interrupt	btfss	intcon,toif
		retfie
		bcf	intcon,toif
		btfss	porta,dcf_in	; testuje vstup dcf_in (porta, bit 4)
		goto	dcf_lo
; *******************************************************
; *** dcf_in je hi, nejdrive otestuje zda jiz hi byl: ***
; *** byl - pripocita 1 k dcf_time_hi, pokud pretece, ***
; ***	    skoci na dcf_time_over		      ***
; *** nebyl - skoci na dcf_change_lo		      ***
; *******************************************************
dcf_hi		btfss	state,dcf_last
		goto	dcf_change_lo
		incfsz	dcf_time_hi
		goto	time
		goto	dcf_time_over
; ********************************************************
; *** dcf_in je lo, nejdrive otestuje, zda jiz lo byl: ***
; *** byl - pricte k dcf_time_lo a dcf_time_low	       ***
; ***	    (druhy rad - pokud pretece prvni rad) 1    ***
; ***	    a pokud je u dcf_time_low bit 3 hi,	       ***
; ***	    nasleduje dcf_time_over, jinak skoci       ***
; ***	    na time				       ***
; *** nebyl - skoci na dcf_change_hi		       ***
; ********************************************************
dcf_lo		btfsc	state,dcf_last
		goto	dcf_change_hi
		incfsz	dcf_time_lo
		goto	time
		incf	dcf_time_low
		btfss	dcf_time_low,over
		goto	time
; ************************************************************
; *** Doslo k prekroceni maximalnich casu na vstupu dcf_in ***
; *** Proto se nastavi signal_error a vynuluje control_ok  ***
; ************************************************************
dcf_time_over	bsf	state,signal_error
		bcf	state,control_ok
		goto	time
; ************************************************************
; *** Doslo ke zmene na dcf_in z lo na hi, proto se zjisti ***
; *** delka predesleho lo useku				   ***
; *** Pokud byl tento dostatecne dlouhy (dcf_time_low>5),  ***
; *** probehne dalsi zpracovani dcf informace		   ***
; ************************************************************
dcf_change_lo	bsf	state,dcf_last
		clrf	dcf_time_hi
		movlw	$5
		subwf	dcf_time_low,w
		btfss	status,c
		goto	time
; ************************************************************
; *** Po zjisteni dostatecne delky lo useku se zkontroluje ***
; *** hodnota registru counter (ma byt 59 dec), dale zda   ***
; *** nedoslo k chybne delce lo ci hi useku a nastaveni	   ***
; *** paritnich bitu pro min a hour			   ***
; *** Pokud je vse v poradku pokracuje srovnavanim stare   ***
; *** a nove dcf informace (viz nize), jinak skoci na time ***
; ************************************************************
		bsf	state,control_ok
		movlw	$3b
		subwf	counter,f
		btfss	status,z
		bcf	state,control_ok
		clrf	counter
		btfsc	state,signal_error
		bcf	state,control_ok
		bcf	state,signal_error
		btfss	state,parity_min
		bcf	state,control_ok
		bcf	state,parity_min
		btfss	state,parity_hour
		bcf	state,control_ok
		bcf	state,parity_hour
		btfss	state,control_ok
		goto	time
; *************************************************************
; *** Pricte 1 minutu ke stare dcf informaci - pro srovnani ***
; *** stare a nove dcf informace			    ***
; *************************************************************
control_dcf	incf	min_last_lo
		movlw	$A
		subwf	min_last_lo,w
		btfss	status,c
		goto	compare_dcf
		clrf	min_last_lo
		incf	min_last_hi,f
		movlw	$6
		subwf	min_last_hi,w
		btfss	status,c
		goto	compare_dcf
		clrf	min_last_hi
		incf	hour_last_lo,f
		movlw	$4
		btfss	hour_last_hi,two
		movlw	$A
		subwf	hour_last_lo,w
		btfss	status,c
		goto	compare_dcf
		clrf	hour_last_lo
		incf	hour_last_hi,f
		movlw	$3
		subwf	hour_last_hi,w
		btfss	status,c
		goto	compare_dcf
		clrf	hour_last_hi
; ************************************************************
; *** Srovna stary udaj (s prictenou minutou) a novy udaj  ***
; *** a pokud souhlasi, necha nastaveny bit control_ok	   ***
; *** a provede nastaveni casu, reset sekundy a navrat	   ***
; *** Pokud nesouhlasi, pokracuje v normalnim chodu	   ***
; ************************************************************
compare_dcf	movf	min_dcf_lo,w
		subwf	min_last_lo,f
		btfss	status,z
		bcf	state,control_ok
		movwf	min_last_lo
		movf	min_dcf_hi,w
		subwf	min_last_hi,f
		btfss	status,z
		bcf	state,control_ok
		movwf	min_last_hi
		movf	hour_dcf_lo,w
		subwf	hour_last_lo,f
		btfss	status,z
		bcf	state,control_ok
		movwf	hour_last_lo
		movf	hour_dcf_hi,w
		subwf	hour_last_hi,f
		btfss	status,z
		bcf	state,control_ok
		movwf	hour_last_hi
		btfss	state,control_ok
		goto	time
		clrf	tmr0
		clrf	time_prescal
		clrf	time_prescaler
		clrf	sec_lo
		clrf	sec_hi
		movf	min_dcf_lo,w
		movwf	min_lo
		movf	min_dcf_hi,w
		movwf	min_hi
		movf	hour_dcf_lo,w
		movwf	hour_lo
		movf	hour_dcf_hi,w
		movwf	hour_hi
		goto	display
; *******************************************************************
; *** Doslo ke zmene na vstupu dcf_in z hi na lo, proto rozkoduje ***
; *** delku dcf impulsu						  ***
; *** Pri delce vetsi nez dcf_200ms_max a mensi nez dcf_100ms_min ***
; *** skoci na dcf_time_over					  ***
; *******************************************************************
dcf_change_hi	bcf	state,dcf_last
		clrf	dcf_time_lo
		clrf	dcf_time_low
		movlw	dcf_100ms_min
		subwf	dcf_time_hi,w
		btfss	status,c
		goto	dcf_time_over
		movlw	dcf_200ms_max
		subwf	dcf_time_hi,w
		btfsc	status,c
		goto	dcf_time_over
		bcf	state,dcf_bit
		movlw	dcf_100ms_max
		subwf	dcf_time_hi,w
		btfsc	status,c
		bsf	state,dcf_bit
; ***********************************************************************
; *** Zapisovani rozkodovaneho dcf_bit do registru casu a bitu parity ***
; ***********************************************************************
bit_dec_21	movlw	$15
		subwf	counter,w
		btfss	status,z
		goto	bit_dec_22
		clrf	parity_count
		bcf	min_dcf_lo,bit0
		btfsc	state,dcf_bit
		bsf	min_dcf_lo,bit0
		goto	end_of_test
bit_dec_22	movlw	$16
		subwf	counter,w
		btfss	status,z
		goto	bit_dec_23
		bcf	min_dcf_lo,bit1
		btfsc	state,dcf_bit
		bsf	min_dcf_lo,bit1
		goto	end_of_test
bit_dec_23	movlw	$17
		subwf	counter,w
		btfss	status,z
		goto	bit_dec_24
		bcf	min_dcf_lo,bit2
		btfsc	state,dcf_bit
		bsf	min_dcf_lo,bit2
		goto	end_of_test
bit_dec_24	movlw	$18
		subwf	counter,w
		btfss	status,z
		goto	bit_dec_25
		bcf	min_dcf_lo,bit3
		btfsc	state,dcf_bit
		bsf	min_dcf_lo,bit3
		goto	end_of_test
bit_dec_25	movlw	$19
		subwf	counter,w
		btfss	status,z
		goto	bit_dec_26
		bcf	min_dcf_hi,bit0
		btfsc	state,dcf_bit
		bsf	min_dcf_hi,bit0
		goto	end_of_test
bit_dec_26	movlw	$1A
		subwf	counter,w
		btfss	status,z
		goto	bit_dec_27
		bcf	min_dcf_hi,bit1
		btfsc	state,dcf_bit
		bsf	min_dcf_hi,bit1
		goto	end_of_test
bit_dec_27	movlw	$1B
		subwf	counter,w
		btfss	status,z
		goto	bit_dec_28
		bcf	min_dcf_hi,bit2
		btfsc	state,dcf_bit
		bsf	min_dcf_hi,bit2
		goto	end_of_test
bit_dec_28	movlw	$1C			; parita pro minuty
		subwf	counter,w
		btfss	status,z
		goto	bit_dec_29
		btfsc	state,dcf_bit
		incf	parity_count,f
		btfss	parity_count,bit0
		bsf	state,parity_min
		goto	end_of_test
bit_dec_29	movlw	$1D
		subwf	counter,w
		btfss	status,z
		goto	bit_dec_30
		clrf	parity_count
		bcf	hour_dcf_lo,bit0
		btfsc	state,dcf_bit
		bsf	hour_dcf_lo,bit0
		goto	end_of_test
bit_dec_30	movlw	$1E
		subwf	counter,w
		btfss	status,z
		goto	bit_dec_31
		bcf	hour_dcf_lo,bit1
		btfsc	state,dcf_bit
		bsf	hour_dcf_lo,bit1
		goto	end_of_test
bit_dec_31	movlw	$1F
		subwf	counter,w
		btfss	status,z
		goto	bit_dec_32
		bcf	hour_dcf_lo,bit2
		btfsc	state,dcf_bit
		bsf	hour_dcf_lo,bit2
		goto	end_of_test
bit_dec_32	movlw	$20
		subwf	counter,w
		btfss	status,z
		goto	bit_dec_33
		bcf	hour_dcf_lo,bit3
		btfsc	state,dcf_bit
		bsf	hour_dcf_lo,bit3
		goto	end_of_test
bit_dec_33	movlw	$21
		subwf	counter,w
		btfss	status,z
		goto	bit_dec_34
		bcf	hour_dcf_hi,bit0
		btfsc	state,dcf_bit
		bsf	hour_dcf_hi,bit0
		goto	end_of_test
bit_dec_34	movlw	$22
		subwf	counter,w
		btfss	status,z
		goto	bit_dec_35
		bcf	hour_dcf_hi,bit1
		btfsc	state,dcf_bit
		bsf	hour_dcf_hi,bit1
		goto	end_of_test
bit_dec_35	movlw	$23			; parita pro hodiny
		subwf	counter,w
		btfss	status,z
		goto	end_of_test
		btfsc	state,dcf_bit
		incf	parity_count,f
		btfss	parity_count,bit0
		bsf	state,parity_hour
end_of_test	btfsc	state,dcf_bit
		incf	parity_count,f
		incf	counter,f
; *********************************************************
; *** Zde se pocitaji preruseni a pri kazdem 874 - tem  ***
; *** se pricte 1 sekunda k casu v registrech a zobrazi ***
; *** se casova informace				***
; *********************************************************
time		incfsz	time_prescal
		goto	time_pre_1
		incf	time_prescaler
		goto	display
time_pre_1	movlw	$3
		subwf	time_prescaler,w
		btfss	status,z
		goto	display
		movlw	$6A
		subwf	time_prescal,w
		btfss	status,z
		goto	display
		clrf	time_prescal
		clrf	time_prescaler
; *****************************************
; *** Pricte sekundu a ohlida preteceni ***
; *** jednotlivych registru casu	***
; *****************************************
plus_second	incf	sec_lo,f
		movlw	$A
		subwf	sec_lo,w
		btfss	status,c
		goto	display
		clrf	sec_lo
		incf	sec_hi,f
		movlw	$6
		subwf	sec_hi,w
		btfss	status,c
		goto	display
		clrf	sec_hi
		incf	min_lo,f
		movlw	$A
		subwf	min_lo,w
		btfss	status,c
		goto	display
		clrf	min_lo
		incf	min_hi,f
		movlw	$6
		subwf	min_hi,w
		btfss	status,c
		goto	display
		clrf	min_hi
		incf	hour_lo,f
		movlw	$4
		btfss	hour_hi,two
		movlw	$A
		subwf	hour_lo,w
		btfss	status,c
		goto	display
		clrf	hour_lo
		incf	hour_hi,f
		movlw	$3
		subwf	hour_hi,w
		btfss	status,c
		goto	display
		clrf	hour_hi
; **************************************************
; *** Zobrazi registry casu na ktere se odvolava ***
; *** predchozi pricitani sekundy a DCF dekoder, ***
; *** dle control_ok signalizuje stav LED na rb7 ***
; **************************************************
display		movf	pointer,w
		sublw	$18
		movwf	fsr
		swapf	pointer,w
		iorwf	indf,w
		btfss	state,control_ok
		iorlw	$80
		movwf	portb
		decfsz	pointer
		retfie
		movlw	$6
		movwf	pointer
		retfie
; *************************************************************
; *** Zde zacina program, probehne reset udaju pri spusteni ***
; *************************************************************
start		clrf	dcf_time_lo
		clrf	dcf_time_low
		clrf	dcf_time_hi
		clrf	sec_lo
		clrf	sec_hi
		clrf	min_lo
		clrf	min_hi
		clrf	hour_lo
		clrf	hour_hi
		clrf	min_dcf_lo
		clrf	min_dcf_hi
		clrf	hour_dcf_lo
		clrf	hour_dcf_hi
		clrf	min_last_lo
		clrf	min_last_hi
		clrf	hour_last_lo
		clrf	hour_last_hi
		clrf	counter
		clrf	tmr0
		clrf	state
		bsf	state,signal_error
		clrf	time_prescal
		clrf	time_prescaler
		movlw	$6
		movwf	pointer
		bsf	status,rp0
		movlw	$C1
		movwf	option
		movlw	$10
		movwf	trisa
		clrf	trisb
		bcf	status,rp0
		bcf	intcon,toif
		bsf	intcon,toie
		bsf	intcon,gie
; *********************************************
; *** Zde program ceka na preruseni od tmr0 ***
; *********************************************
begin		nop
		goto	begin
end